#!hs2
#!load hamster.hsm

#####################################################################
# Skrypt    : Kill_From.hsc
# Autor     : Nuta <nuta@konto.pl>
# Strona WWW: http://hamster.thebat.pl
# Wersja    : 2001-05-22
# Poprawki  : 2002-05-13
# ===================================================================
# Opis    : Skrypt usuwajcy wszystkie artykuy z zadanej grupy news
#         : pochodzce z podanego adresu nadawcy. Peen opis
#         : dziaania i instalacji skryptu zawarty zosta
#         : w doczanym pliku Kill_From.txt.
#####################################################################

HamRequireVersion("1.3.22.1", True)

Var($Grupa, $Uchwyt, $MaxArt, $NrArt, $TextArt, $Ok)
Var($Nadawca, $Mid, $From, $Licz, $AllArt, $MaxAllArt) 
Var($Start1, $Stop1, $Start2, $Stop2, $LiczArt, $Lista, $Indeks)

repeat
  
  $Nadawca = ""
  repeat
    repeat
      $Nadawca = InputBox("Wpisz adres kasowanego nadawcy (np. login@domena.pl):", "Kill_From - kasowanie artykuw wybranego nadawcy", $Nadawca, $Ok)
      if ($Ok=0)
        quit
      endif
    until ($Nadawca <> "")
    if ((pos("@", $Nadawca) = 0) || (pos(".", $Nadawca) = 0))
      MsgBox("Adres: "+$Nadawca+" jest nieprawidowy!"+chr(10)+"Wpisz poprawny adres e-mail nadawcy.", "Kill_From - kasowanie artykuw wybranego nadawcy", 0x10|0x0)
    endif
  until ((pos("@", $Nadawca) > 0) && (pos(".", $Nadawca) > 0) && ($Ok <> 0))
  
  $Grupa = ""
  repeat
    $Lista = ListAlloc
    ListLoad($Lista, HamPath + "Groups.hst") 
    $Indeks = ListBox( $Lista, "Wybierz nazw grupy news do analizy:", "Kill_From - kasowanie artykuw nadawcy",, $Ok)
    if ($Ok=0)
      ListFree($Lista)
      quit
    endif
    $Grupa = ListGet($Lista,$Indeks)
    ListFree($Lista)

    $Uchwyt = HamGroupOpen($Grupa)
    if ($Uchwyt < 0)
      MsgBox("Grupa: "+$Grupa+" nie istnieje!"+chr(10)+"Musisz wpisa istniejc w Hamsterze nazw grupy.", "Kill_From - kasowanie artykuw wybranego nadawcy", 0x10|0x0)
    endif
  until (($Grupa <> "") && ($Uchwyt >= 0))
  
  $NrArt = HamArtNoMin($Uchwyt)
  $MaxArt = HamArtNoMax($Uchwyt)
  $AllArt = HamArtCount($Uchwyt)
  $MaxAllArt = $MaxArt-$NrArt
  $LiczArt = 0
  $Licz = 0
  $Start1 = ticks

  print
  if ($AllArt > 0)
    print("Grupa: ",$Grupa," zawiera ",$MaxAllArt+1," artykuw z czego ",$AllArt," niepustych. Prosz czeka...")
  else
    HamGroupClose($Uchwyt)
    print("Grupa: ",$Grupa," nie zawiera niepustych artykuw do analizy!")
    quit
  endif
  
  $Start2 = ticks
  while ($NrArt <= $MaxArt)
    $TextArt = HamArtText($Uchwyt, $NrArt)
    if ($TextArt <> "")      
      if (pos($Nadawca, $TextArt) > 0)
        RE_Parse($TextArt, "\nFrom:\s+(.+@.+)\r", $From)
        if (pos($Nadawca, $From) > 0)
          RE_Parse($TextArt, "\nMessage-ID:\s+(<.+@.+>)\r", $Mid)
          HamArtDeleteMid($Mid)
          print("Skasowano artyku nr: ",$NrArt,"  M-ID: ",$Mid)
          inc($Licz)
        endif
      endif
      inc($LiczArt)
    endif  
    inc($NrArt)
  
    $Stop1 = ticks
    if (($Stop1-$Start1) > 30000)
      print("Wykonano ",100-Int(($AllArt-$LiczArt)/($AllArt/100)),"% zadania. Pozostao jeszcze ",$AllArt-$LiczArt," artykuw do analizy. Czekaj...")
      $Start1 = ticks
    endif
  endwhile
  
  $Stop2 = ticks
  HamGroupClose($Uchwyt)
  
  print
  print("W grupie: ",$Grupa," znajdowao si ",$AllArt," niepustych artykuw, z ktrych")
  if ($Licz > 0)
    print($Licz," pochodzcych od nadawcy: ",$Nadawca," skasowano.")
  else
    print("aden nie zosta wysany z adresu: ",$Nadawca)
  endif
  
  if ((($Stop2-$Start2)/1000) > 0)
    print("Skrypt wykonywa si ",Int(($Stop2-$Start2)/1000)," sek. ze redni szybkoci ok. ",Int($MaxAllArt/(($Stop2-$Start2)/1000))," artykuw/sek.")
  else
    print("Skrypt wykonywa si 0,",Int($Stop2-$Start2)," sekundy.")
  endif
  
until (Msgbox("Czy ponawiasz prb dla innego zestawu danych?", "Kill_From - kasowanie artykuw wybranego nadawcy",0x20|0x4) = 7)

quit
